Index: src/World.hpp
===================================================================
--- src/World.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/World.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -23,4 +23,7 @@
 #include "Patterns/Cacheable.hpp"
 #include "Patterns/Singleton.hpp"
+#include "Patterns/ObservedContainer.hpp"
+#include "Helpers/Range.hpp"
+#include "AtomSet.hpp"
 
 // include config.h
@@ -34,6 +37,8 @@
 class AtomDescriptor_impl;
 template<typename T> class AtomsCalculation;
+class Box;
 class config;
 class ManipulateAtomsProcess;
+class Matrix;
 class molecule;
 class MoleculeDescriptor;
@@ -43,4 +48,5 @@
 class ThermoStatContainer;
 
+
 /****************************************** forward declarations *****************************/
 
@@ -58,4 +64,7 @@
 friend class MoleculeDescriptor_impl;
 friend class MoleculeDescriptor;
+// coupling with descriptors over selection
+friend class AtomSelectionDescriptor_impl;
+friend class MoleculeSelectionDescriptor_impl;
 
 // Actions, calculations etc associated with the World
@@ -63,8 +72,13 @@
 template<typename> friend class AtomsCalculation;
 public:
+  // some typedefs for the CONSTRUCT_... macros (no "," allows in a single parameter name)
+  typedef std::map<atomId_t,atom*> AtomSTLSet;
+  typedef std::map<moleculeId_t,molecule*> MoleculeSTLSet;
 
   // Types for Atom and Molecule structures
-  typedef std::map<atomId_t,atom*> AtomSet;
-  typedef std::map<moleculeId_t,molecule*> MoleculeSet;
+  typedef ObservedContainer< AtomSTLSet > AtomSet;
+  typedef ObservedContainer< MoleculeSTLSet > MoleculeSet;
+
+  typedef ATOMSET(std::vector) AtomComposite;
 
   /***** getter and setter *****/
@@ -89,6 +103,6 @@
    * returns a vector containing all atoms that match a given descriptor
    */
-  std::vector<atom*> getAllAtoms(AtomDescriptor descriptor);
-  std::vector<atom*> getAllAtoms();
+  AtomComposite getAllAtoms(AtomDescriptor descriptor);
+  AtomComposite getAllAtoms();
 
   /**
@@ -125,5 +139,12 @@
    * get the domain size as a symmetric matrix (6 components)
    */
-  double * getDomain();
+  Box& getDomain();
+
+  /**
+   * Set the domain size from a matrix object
+   *
+   * Matrix needs to be symmetric
+   */
+  void setDomain(const Matrix &mat);
 
   /**
@@ -201,4 +222,12 @@
 
   /**
+   * used when changing an molecule Id.
+   * Unless you are calling this method from inside an moleucle don't fiddle with the third parameter.
+   *
+   * Return value indicates wether the change could be done or not.
+   */
+  bool changeMoleculeId(moleculeId_t oldId, moleculeId_t newId, molecule* target=0);
+
+  /**
    * Produces a process that calls a function on all Atoms matching a given descriptor. The process is not
    * called at this time, so it can be passed around, stored inside menuItems etc.
@@ -207,9 +236,84 @@
   ManipulateAtomsProcess* manipulateAtoms(boost::function<void(atom*)>,std::string);
 
+  /****
+   * Iterators to use internal data structures
+   * All these iterators are observed to track changes.
+   * There is a corresponding protected section with unobserved iterators,
+   * which can be used internally when the extra speed is needed
+   */
+
+  typedef SelectiveIterator<atom*,AtomSet,AtomDescriptor>       AtomIterator;
+
+  /**
+   * returns an iterator over all Atoms matching a given descriptor.
+   * This iterator is observed, so don't keep it around unnecessary to
+   * avoid unintended blocking.
+   */
+  AtomIterator getAtomIter(AtomDescriptor descr);
+  AtomIterator getAtomIter();
+
+  AtomIterator atomEnd();
+
+  typedef SelectiveIterator<molecule*,MoleculeSet,MoleculeDescriptor>   MoleculeIterator;
+
+  /**
+   * returns an iterator over all Molecules matching a given descriptor.
+   * This iterator is observed, so don't keep it around unnecessary to
+   * avoid unintended blocking.
+   */
+  MoleculeIterator getMoleculeIter(MoleculeDescriptor descr);
+  MoleculeIterator getMoleculeIter();
+
+  MoleculeIterator moleculeEnd();
+
+  /******** Selections of molecules and Atoms *************/
+  void clearAtomSelection();
+  void selectAtom(atom*);
+  void selectAtom(atomId_t);
+  void selectAllAtoms(AtomDescriptor);
+  void selectAtomsOfMolecule(molecule*);
+  void selectAtomsOfMolecule(moleculeId_t);
+  void unselectAtom(atom*);
+  void unselectAtom(atomId_t);
+  void unselectAllAtoms(AtomDescriptor);
+  void unselectAtomsOfMolecule(molecule*);
+  void unselectAtomsOfMolecule(moleculeId_t);
+  size_t countSelectedAtoms() const;
+  bool isSelected(atom *_atom) const;
+  const std::vector<atom *> getSelectedAtoms() const;
+
+  void clearMoleculeSelection();
+  void selectMolecule(molecule*);
+  void selectMolecule(moleculeId_t);
+  void selectAllMolecules(MoleculeDescriptor);
+  void selectMoleculeOfAtom(atom*);
+  void selectMoleculeOfAtom(atomId_t);
+  void unselectMolecule(molecule*);
+  void unselectMolecule(moleculeId_t);
+  void unselectAllMolecules(MoleculeDescriptor);
+  void unselectMoleculeOfAtom(atom*);
+  void unselectMoleculeOfAtom(atomId_t);
+  size_t countSelectedMolecules() const;
+  bool isSelected(molecule *_mol) const;
+  const std::vector<molecule *> getSelectedMolecules() const;
+
+  /******************** Iterators to selections *****************/
+  typedef AtomSet::iterator AtomSelectionIterator;
+  AtomSelectionIterator beginAtomSelection();
+  AtomSelectionIterator endAtomSelection();
+
+  typedef MoleculeSet::iterator MoleculeSelectionIterator;
+  MoleculeSelectionIterator beginMoleculeSelection();
+  MoleculeSelectionIterator endMoleculeSelection();
+
 protected:
-  /**** Iterators to use internal data structures */
+  /****
+   * Iterators to use internal data structures
+   * All these iterators are unobserved for speed reasons.
+   * There is a corresponding public section to these methods,
+   * which produce observed iterators.*/
 
   // Atoms
-  typedef SelectiveIterator<atom*,AtomSet,AtomDescriptor> AtomIterator;
+  typedef SelectiveIterator<atom*,AtomSet::set_t,AtomDescriptor>        internal_AtomIterator;
 
   /**
@@ -217,5 +321,5 @@
    * used for internal purposes, like AtomProcesses and AtomCalculations.
    */
-  AtomIterator getAtomIter(AtomDescriptor descr);
+  internal_AtomIterator getAtomIter_internal(AtomDescriptor descr);
 
   /**
@@ -225,9 +329,9 @@
    * used for internal purposes, like AtomProcesses and AtomCalculations.
    */
-  AtomIterator atomEnd();
+  internal_AtomIterator atomEnd_internal();
 
   // Molecules
-
-  typedef SelectiveIterator<molecule*,MoleculeSet,MoleculeDescriptor> MoleculeIterator;
+  typedef SelectiveIterator<molecule*,MoleculeSet::set_t,MoleculeDescriptor>   internal_MoleculeIterator;
+
 
   /**
@@ -235,5 +339,5 @@
    * used for internal purposes, like MoleculeProcesses and MoleculeCalculations.
    */
-  MoleculeIterator getMoleculeIter(MoleculeDescriptor descr);
+  internal_MoleculeIterator getMoleculeIter_internal(MoleculeDescriptor descr);
 
   /**
@@ -243,5 +347,5 @@
    * used for internal purposes, like MoleculeProcesses and MoleculeCalculations.
    */
-  MoleculeIterator moleculeEnd();
+  internal_MoleculeIterator moleculeEnd_internal();
 
 
@@ -254,18 +358,44 @@
   void releaseAtomId(atomId_t);
   bool reserveAtomId(atomId_t);
+  void defragAtomIdPool();
+
+  moleculeId_t getNextMoleculeId();
+  void releaseMoleculeId(moleculeId_t);
+  bool reserveMoleculeId(moleculeId_t);
+  void defragMoleculeIdPool();
 
   periodentafel *periode;
   config *configuration;
-  static double *cell_size;
+  Box *cell_size;
   std::string defaultName;
   class ThermoStatContainer *Thermostats;
   int ExitFlag;
-public:
+private:
+
   AtomSet atoms;
-private:
-  std::set<atomId_t> atomIdPool; //<!stores the pool for all available AtomIds below currAtomId
+  AtomSet selectedAtoms;
+  typedef std::set<range<atomId_t> > atomIdPool_t;
+  /**
+   * stores the pool for all available AtomIds below currAtomId
+   *
+   * The pool contains ranges of free ids in the form [bottom,top).
+   */
+  atomIdPool_t atomIdPool;
   atomId_t currAtomId; //!< stores the next available Id for atoms
+  size_t lastAtomPoolSize; //!< size of the pool after last defrag, to skip some defrags
+  unsigned int numAtomDefragSkips;
+
   MoleculeSet molecules;
+  MoleculeSet selectedMolecules;
+  typedef std::set<range<atomId_t> > moleculeIdPool_t;
+  /**
+   * stores the pool for all available AtomIds below currAtomId
+   *
+   * The pool contains ranges of free ids in the form [bottom,top).
+   */
+  moleculeIdPool_t moleculeIdPool;
   moleculeId_t currMoleculeId;
+  size_t lastMoleculePoolSize; //!< size of the pool after last defrag, to skip some defrags
+  unsigned int numMoleculeDefragSkips;
 private:
   /**
Index: src/analysis_bonds.cpp
===================================================================
--- src/analysis_bonds.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/analysis_bonds.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,6 +17,7 @@
 #include "bond.hpp"
 #include "element.hpp"
-#include "info.hpp"
-#include "log.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 
@@ -59,7 +65,7 @@
   int AtomNo = 0;
   for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-    if ((*iter)->type == type1)
+    if ((*iter)->getType() == type1)
       for (BondList::const_iterator BondRunner = (*iter)->ListOfBonds.begin(); BondRunner != (*iter)->ListOfBonds.end(); BondRunner++)
-        if ((*BondRunner)->GetOtherAtom((*iter))->type == type2) {
+        if ((*BondRunner)->GetOtherAtom((*iter))->getType() == type2) {
           const double distance = (*BondRunner)->GetDistanceSquared();
           if (Min > distance)
@@ -86,11 +92,11 @@
  * \return angle between \a *first and \a *second, both relative to origin at \a *origin.
  */
-double CalculateAngle(Vector *first, Vector *central, Vector *second)
+double CalculateAngle(const Vector &first, const Vector &central, const Vector &second)
 {
   Vector OHBond;
   Vector OOBond;
 
-  OHBond = (*first) - (*central);
-  OOBond = (*second) - (*central);
+  OHBond = first - central;
+  OOBond = second - central;
   const double angle = OHBond.Angle(OOBond);
   return angle;
@@ -109,5 +115,5 @@
 
   // check angle
-  if (CalculateAngle(&Hydrogen->x, &Oxygen->x, &OtherOxygen->x) < M_PI*(30./180.)) {
+  if (CalculateAngle(Hydrogen->getPosition(), Oxygen->getPosition(), OtherOxygen->getPosition()) < M_PI*(30./180.)) {
     return true;
   } else {
@@ -137,7 +143,7 @@
         molecule::iterator Runner = (*MolRunner)->begin();
         for(;Runner!=(*MolRunner)->end();++Runner){
-          if (((*Walker)->type->Z  == 8) && ((*Runner)->type->Z  == 8)) {
+          if (((*Walker)->getType()->Z  == 8) && ((*Runner)->getType()->Z  == 8)) {
             // check distance
-            const double distance = (*Runner)->x.DistanceSquared((*Walker)->x);
+            const double distance = (*Runner)->DistanceSquared(*(*Walker));
             if ((distance > MYEPSILON) && (distance < HBRIDGEDISTANCE*HBRIDGEDISTANCE)) { // distance >0 means  different atoms
               // on other atom(Runner) we check for bond to interface element and
@@ -151,12 +157,12 @@
                 atom * const OtherAtom = (*BondRunner)->GetOtherAtom(*Runner);
                 // if hydrogen, check angle to be greater(!) than 30 degrees
-                if (OtherAtom->type->Z == 1) {
-                  const double angle = CalculateAngle(&OtherAtom->x, &(*Runner)->x, &(*Walker)->x);
+                if (OtherAtom->getType()->Z == 1) {
+                  const double angle = CalculateAngle(OtherAtom->getPosition(), (*Runner)->getPosition(), (*Walker)->getPosition());
                   OtherHydrogenFlag = OtherHydrogenFlag && (angle > M_PI*(30./180.) + MYEPSILON);
                   Otherangle += angle;
                   OtherHydrogens++;
                 }
-                InterfaceFlag = InterfaceFlag || (OtherAtom->type == InterfaceElement);
-                Interface2Flag = Interface2Flag || (OtherAtom->type == Interface2Element);
+                InterfaceFlag = InterfaceFlag || (OtherAtom->getType() == InterfaceElement);
+                Interface2Flag = Interface2Flag || (OtherAtom->getType() == Interface2Element);
               }
               DoLog(1) && (Log() << Verbose(1) << "Otherangle is " << Otherangle << " for " << OtherHydrogens << " hydrogens." << endl);
@@ -176,8 +182,8 @@
                 for (BondList::const_iterator BondRunner = (*Walker)->ListOfBonds.begin(); BondRunner != (*Walker)->ListOfBonds.end(); BondRunner++) {
                   atom * const OtherAtom = (*BondRunner)->GetOtherAtom(*Walker);
-                  if (OtherAtom->type->Z == 1) {
+                  if (OtherAtom->getType()->Z == 1) {
                     // check angle
                     if (CheckHydrogenBridgeBondAngle(*Walker, OtherAtom, *Runner)) {
-                      DoLog(1) && (Log() << Verbose(1) << (*Walker)->getName() << ", " << OtherAtom->getName() << " and " << (*Runner)->getName() << " has a hydrogen bridge bond with distance " << sqrt(distance) << " and angle " << CalculateAngle(&OtherAtom->x, &(*Walker)->x, &(*Runner)->x)*(180./M_PI) << "." << endl);
+                      DoLog(1) && (Log() << Verbose(1) << (*Walker)->getName() << ", " << OtherAtom->getName() << " and " << (*Runner)->getName() << " has a hydrogen bridge bond with distance " << sqrt(distance) << " and angle " << CalculateAngle(OtherAtom->getPosition(), (*Walker)->getPosition(), (*Runner)->getPosition())*(180./M_PI) << "." << endl);
                       count++;
                       break;
@@ -209,10 +215,10 @@
     for(;Walker!=(*MolWalker)->end();++Walker){
       atom * theAtom = *Walker;
-      if ((theAtom->type == first) || (theAtom->type == second)) {  // first element matches
+      if ((theAtom->getType() == first) || (theAtom->getType() == second)) {  // first element matches
         for (BondList::const_iterator BondRunner = theAtom->ListOfBonds.begin(); BondRunner != theAtom->ListOfBonds.end(); BondRunner++) {
           atom * const OtherAtom = (*BondRunner)->GetOtherAtom(theAtom);
-          if (((OtherAtom->type == first) || (OtherAtom->type == second)) && (theAtom->nr < OtherAtom->nr)) {
+          if (((OtherAtom->getType() == first) || (OtherAtom->getType() == second)) && (theAtom->nr < OtherAtom->nr)) {
             count++;
-            DoLog(1) && (Log() << Verbose(1) << first->name << "-" << second->name << " bond found between " << *Walker << " and " << *OtherAtom << "." << endl);
+            DoLog(1) && (Log() << Verbose(1) << *first << "-" << *second << " bond found between " << *Walker << " and " << *OtherAtom << "." << endl);
           }
         }
@@ -245,5 +251,5 @@
     for(;Walker!=(*MolWalker)->end();++Walker){
       atom *theAtom = *Walker;
-      if (theAtom->type == second) {  // first element matches
+      if (theAtom->getType() == second) {  // first element matches
         for (int i=0;i<2;i++)
           MatchFlag[i] = false;
@@ -251,5 +257,5 @@
           atom * const OtherAtom = (*BondRunner)->GetOtherAtom(theAtom);
           for (int i=0;i<2;i++)
-            if ((!MatchFlag[i]) && (OtherAtom->type == ElementArray[i])) {
+            if ((!MatchFlag[i]) && (OtherAtom->getType() == ElementArray[i])) {
               MatchFlag[i] = true;
               break;  // each bonding atom can match at most one element we are looking for
@@ -261,5 +267,5 @@
         if (result) { // check results
           count++;
-          DoLog(1) && (Log() << Verbose(1) << first->name << "-" << second->name << "-" << third->name << " bond found at " << *Walker << "." << endl);
+          DoLog(1) && (Log() << Verbose(1) << *first << "-" << *second << "-" << *third << " bond found at " << *Walker << "." << endl);
         }
       }
Index: src/analysis_bonds.hpp
===================================================================
--- src/analysis_bonds.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/analysis_bonds.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -20,5 +20,5 @@
 /*********************************************** defines ***********************************/
 
-#define HBRIDGEDISTANCE 3.5   //!< HBridge distance from PCCP Vol 10. 4802-4813
+const double HBRIDGEDISTANCE=3.5;   //!< HBridge distance from PCCP Vol 10. 4802-4813
 
 /****************************************** forward declarations *****************************/
